#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Sep 1 19:16:36 2019

@author: curso

Árboles de decisión Regresión

"""
########## LIBRERÍAS  ##########
#Importación de las librerias necesarias
import numpy as np
import matplotlib.pyplot as plt
from sklearn import datasets

########## PREPARAR los datos ##########
#Importamos los datos de la librería de boston 
boston = datasets.load_boston()
print(boston)
print()

########## COMPRENSIÓN DE LOS DATOS  ##########
#comprobar la información que contiene el dataset
print('Información en el dataset:')
print(boston.keys())
print()


#Verificar las características del dataset
print('Características del dataset:')
print(boston.DESCR)

#Verificar la cantidad de datos que hay en los dataset
print('Cantidad de datos:')
print(boston.data.shape)
print()

#Verificar también las columnas o atributos
print('Nombres de los atributos:')
print(boston.feature_names)


########## PREPARAR los Datos para ADR ##########
#Seleccionamos la columna 6 del dataset
X_adr = boston.data[:,np.newaxis, 5]

#Definir  los datos correspondientes a las etiquetas
#variable y dependiente u objetivo
y_adr = boston.target

#Representamos gráficamente los datos correspondientes
plt.scatter(X_adr, y_adr)
plt.show()


########## ADR  ##########
#Separo los datos de "train" en entrenamiento y prueba para probar los algoritmos
from sklearn.model_selection import train_test_split

X_train, X_test, y_train, y_test = train_test_split(X_adr, y_adr, test_size=0.2)


#Defino el algoritmo a utilizar
from sklearn.tree import DecisionTreeRegressor
adr = DecisionTreeRegressor(max_depth=5 )

#Entrenamiento del modelo
adr.fit(X_train, y_train)

#Realizo una predicción
X_test_ord=np.sort(X_test,axis=0)
Y_pred = adr.predict(X_test_ord)#Y_pred = adr.predict(X_test)

# Representación gráfica de los datos de prueba y el modelo

#X_grid = np.arange(min(X_test), max(X_test), 0.1)[:,np.newaxis]
##X_grid = X_grid.reshape((len(X_grid), 1))
#plt.scatter(X_test, y_test)
#plt.plot(X_grid, adr.predict(X_grid), color='green', linewidth=1)
#plt.show()
plt.scatter(X_test, y_test)
plt.plot(X_test_ord, Y_pred, color='red', linewidth=3)
plt.show()

#### precisión del modelo
print('Precisión del modelo: ',end='')
print('%.3f' % adr.score(X_train, y_train))

