#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Sep 1 19:16:36 2019

@author: curso

Regresión Lineal Múltiple

"""
########## LIBRERÍAS  ##########
#Importación de las librerias necesarias
from sklearn import datasets, linear_model


########## PREPARAR los datos ##########
#Importamos los datos de la librería de boston 
boston = datasets.load_boston()
print(boston)
print()

########## COMPRENSIÓN DE LOS DATOS  ##########
#comprobar la información que contiene el dataset
print('Información en el dataset:')
print(boston.keys())
print()


#Verificar las características del dataset
print('Características del dataset:')
print(boston.DESCR)

#Verificar la cantidad de datos que hay en los dataset
print('Cantidad de datos:')
print(boston.data.shape)
print()

#Verificar también las columnas o atributos
print('Nombres de los atributos:')
print(boston.feature_names)


########## PREPARAR los Datos para REGRESIÓN LINEAL Múltiple ##########
#Seleccionamos las columna 5, 6 y 7 del dataset
X_multiple = boston.data[:, 5:8]
print(X_multiple)

#Definir  los datos correspondientes a las etiquetas
#variable y dependiente u objetivo
y_multiple = boston.target


##########  REGRESIÓN LINEAL Múltiple ##########
from sklearn.model_selection import train_test_split

#Separo los datos de "train" en entrenamiento y prueba para probar los algoritmos
X_train, X_test, y_train, y_test = train_test_split(X_multiple, y_multiple, test_size=0.2)

#Defino el algoritmo a utilizar
lr_multiple = linear_model.LinearRegression()

#Entrenamiento del modelo
lr_multiple.fit(X_train, y_train)

#Realizo una predicción
Y_pred_multiple = lr_multiple.predict(X_test)

#Valores de la ecuación del modelo de regresión
print('VALORES DEL MODELO DE REGRESIÓN LINEAL MÚLTIPLE \n')
a1 = lr_multiple.coef_[0]
a2 = lr_multiple.coef_[1]
a3 = lr_multiple.coef_[2]
constante = lr_multiple.intercept_
print('La ecuación del modelo es:')
print('y = %.3f x1 %+.3f x2 %+.3f x3 %+.3f '  %(a1,a2,a3,constante))

#### precisión del modelo
print('Precisión del modelo: ',end='')
print('%.3f' % lr_multiple.score(X_train, y_train))


