#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Sep 1 19:16:36 2019

@author: curso

Regresión Lineal Simple

"""
########## LIBRERÍAS  ##########
#Importación de las librerias necesarias
import numpy as np
import matplotlib.pyplot as plt
from sklearn import datasets, linear_model


########## PREPARAR los datos ##########
#Importamos los datos de la librería de boston 
boston = datasets.load_boston()
print(boston)
print()

########## COMPRENSIÓN DE LOS DATOS  ##########
#comprobar la información que contiene el dataset
print('Información en el dataset:')
print(boston.keys())
print()


#Verificar las características del dataset
print('Características del dataset:')
print(boston.DESCR)

#Verificar la cantidad de datos que hay en los dataset
print('Cantidad de datos:')
print(boston.data.shape)
print()

#Verificar también las columnas o atributos
print('Nombres de los atributos:')
print(boston.feature_names)


########## PREPARAR los Datos para REGRESIÓN LINEAL SIMPLE ##########
#Nos quedamos con la columna 5 del dataset
X = boston.data[:, np.newaxis, 5]

#Definir  los datos correspondientes a las etiquetas
#variable y dependiente u objetivo
y = boston.target

#Mostrar el gráfico de dispersión de los datos
plt.scatter(X, y)
plt.xlabel('Número de habitaciones')
plt.ylabel('Valor medio')
plt.show()

##########  REGRESIÓN LINEAL SIMPLE ##########
from sklearn.model_selection import train_test_split

#Separo los datos de "train" en entrenamiento y prueba para probar los algoritmos
X_train, X_test, y_train, y_test = train_test_split(X, y, test_size=0.2)

#Defino el algoritmo a utilizar
lr = linear_model.LinearRegression()

#Entrenamiento del modelo
lr.fit(X_train, y_train)
#Realizo una predicción
Y_pred = lr.predict(X_test)


#Reprentamos gráficamente los datos junto con el modelo
plt.scatter(X_test, y_test)
plt.plot(X_test, Y_pred, color='red', linewidth=3)
plt.title('Regresión Lineal Simple')
plt.xlabel('Número de habitaciones')
plt.ylabel('Valor medio')
plt.show()
print()

#Valores de la ecuación del modelo de regresión
print('VALORES DEL MODELO DE REGRESIÓN LINEAL SIMPLE \n')
pendiente = lr.coef_
constante = lr.intercept_
print('La ecuación del modelo es:')
print('y = ', pendiente, 'x +', constante)

#### precisión del modelo
print('Precisión del modelo: ',end='')
print("%.3f" % lr.score(X_train, y_train))


