#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Sep 1 19:16:36 2019

@author: curso

Regresión Polinómica

"""
########## LIBRERÍAS  ##########
#Importación de las librerias necesarias
import numpy as np
import matplotlib.pyplot as plt
from sklearn import datasets, linear_model


########## PREPARAR los datos ##########
#Importamos los datos de la librería de boston 
boston = datasets.load_boston()
print(boston)
print()

########## COMPRENSIÓN DE LOS DATOS  ##########
#comprobar la información que contiene el dataset
print('Información en el dataset:')
print(boston.keys())
print()


#Verificar las características del dataset
print('Características del dataset:')
print(boston.DESCR)

#Verificar la cantidad de datos que hay en los dataset
print('Cantidad de datos:')
print(boston.data.shape)
print()

#Verificar también las columnas o atributos
print('Nombres de los atributos:')
print(boston.feature_names)


########## PREPARAR los Datos para REGRESIÓN POLINÓMICA ##########
#Seleccionamos la columna 6 del dataset
X_p = boston.data[:,np.newaxis, 5]

#Definir  los datos correspondientes a las etiquetas
#variable y dependiente u objetivo
y_p = boston.target

#Representamos gráficamente los datos correspondientes
plt.scatter(X_p, y_p)
plt.show()


##########  REGRESIÓN POLINÓMICA ##########
#Separo los datos de "train" en entrenamiento y prueba para probar los algoritmos
from sklearn.model_selection import train_test_split

X_train_p, X_test_p, y_train_p, y_test_p = train_test_split(X_p, y_p, test_size=0.2)

#Se define el grado del polinomio
from sklearn.preprocessing import PolynomialFeatures

poli_reg = PolynomialFeatures(degree = 2)

#Se transforma las características existentes en características de mayor grado
X_train_poli = poli_reg.fit_transform(X_train_p)
#X_test_p_ord=np.sort(X_test_p,axis=0)
X_test_poli = poli_reg.fit_transform(X_test_p)


#Defino el algoritmo a utilizar
pr = linear_model.LinearRegression()

#Entrenamiento del modelo
pr.fit(X_train_poli, y_train_p)

#Realizo una predicción
Y_pred_pr = pr.predict(X_test_poli)

# Representación gráfica de los datos de prueba y el modelo
plt.scatter(X_test_p, y_test_p)
plt.plot(X_test_p, Y_pred_pr, color='red', linewidth=1)
#plt.scatter(X_test_p, Y_pred_pr, color='green')
plt.show()


#Valores del modelo de regresión polinómica
print('VALORES DEL MODELO DE REGRESIÓN POLINÓMICA \n')
print(pr.coef_)
constante = pr.intercept_
print('Valor de la intersección o coeficiente "b": ',end='')
print(pr.intercept_)

#### precisión del modelo
print('Precisión del modelo: ',end='')
print('%.3f' % pr.score(X_train_poli, y_train_p))


