#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Sep 1 19:16:36 2019

@author: curso

Máquinas Vectores de Soporte Clasificación

"""
########## LIBRERÍAS  ##########
#Importación de las librerias necesarias
from sklearn import datasets

########## PREPARAR los datos ##########
#Importamos los datos de la librería breast_cancer
dataset = datasets.load_breast_cancer()
#print(dataset)
#print()


########## COMPRENSIÓN DE LOS DATOS  ##########
#comprobar la información que contiene el dataset
print('Información en el dataset:')
print(dataset.keys())
print()


#Verificar las características del dataset
print('Características del dataset:')
#print(dataset.DESCR)

#Verificar la cantidad de datos que hay en los dataset
print('Cantidad de datos:')
print(dataset.data.shape)
print()

#Verificar también las columnas o atributos
print('Nombres de los atributos:')
print(dataset.feature_names)


########## PREPARAR los Datos para SVM Clasificación ##########
#Seleccionamos todas las columnas
X = dataset.data


#Definir  los datos correspondientes a las etiquetas
#variable y dependiente u objetivo
y = dataset.target

########## SVM Clasificación ##########
#Separo los datos de "train" en entrenamiento y prueba para probar los algoritmos
from sklearn.model_selection import train_test_split

X_train, X_test, y_train, y_test = train_test_split(X, y, test_size=0.2)

#Defino el algoritmo a utilizar
from sklearn.svm import SVC

algoritmo = SVC(kernel='linear')

#Entrenamiento del modelo
algoritmo.fit(X_train, y_train)

#Realizo una predicción
y_pred = algoritmo.predict(X_test)

#Verifico la matriz de Confusión
from sklearn.metrics import confusion_matrix

matriz = confusion_matrix(y_test,y_pred)
print('Matriz de Confusión:')
print(matriz)

#Calculo la precisión del modelo
from sklearn.metrics import precision_score
precision = precision_score(y_test, y_pred)
print('Precisión del modelo:')
print(precision)

