#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Sep 1 19:16:36 2019

@author: curso

Support Vector regression (SVR)

"""
########## LIBRERÍAS  ##########
#Importación de las librerias necesarias
import numpy as np
import matplotlib.pyplot as plt
from sklearn import datasets

########## PREPARAR los datos ##########
#Importamos los datos de la librería de boston 
boston = datasets.load_boston()
print(boston)
print()

########## COMPRENSIÓN DE LOS DATOS  ##########
#comprobar la información que contiene el dataset
print('Información en el dataset:')
print(boston.keys())
print()


#Verificar las características del dataset
print('Características del dataset:')
print(boston.DESCR)

#Verificar la cantidad de datos que hay en los dataset
print('Cantidad de datos:')
print(boston.data.shape)
print()

#Verificar también las columnas o atributos
print('Nombres de los atributos:')
print(boston.feature_names)


########## PREPARAR los Datos para SVR ##########
#Seleccionamos la columna 6 del dataset
X_svr = boston.data[:,np.newaxis, 5]

#Definir  los datos correspondientes a las etiquetas
#variable y dependiente u objetivo
y_svr = boston.target

#Representamos gráficamente los datos correspondientes
plt.scatter(X_svr, y_svr)
plt.show()


########## SVR  ##########
#Separo los datos de "train" en entrenamiento y prueba para probar los algoritmos
from sklearn.model_selection import train_test_split

X_train, X_test, y_train, y_test = train_test_split(X_svr, y_svr, test_size=0.2)


#Defino el algoritmo a utilizar
from sklearn.svm import SVR
svr = SVR(kernel='linear', C=1.0, epsilon=0.2)
#svr = SVR()

#Entrenamiento del modelo
svr.fit(X_train, y_train)

#Realizo una predicción
Y_pred = svr.predict(X_test)

# Representación gráfica de los datos de prueba y el modelo
plt.scatter(X_test, y_test)
plt.plot(X_test, Y_pred, color='red', linewidth=3)
#plt.scatter(X_test, Y_pred, color='green')
plt.show()


#### precisión del modelo
print('Precisión del modelo: ',end='')
print('%.3f' % svr.score(X_train, y_train))

